
subroutine rect2pol( rectmap, nx, ox, dx, nz, oz, dz ,
		     polmap, nth, oth, dth, nr, or, dr ,
		     xshot, zshot )

integer nx,nz,nth,nr
real ox,oz,oth,or,dx,dz,dth,dr,xshot,zshot

real rectmap(nz,nx)
real polmap(nth,nr)

real PI,xmax,zmax,rmax,rr,xx,zz,theta,ddx,ddz
real a11,a12,a21,a22
integer it,ir,ix,iz

real bilint
bilint(ddz,ddx,a11,a21,a12,a22) =
(1-ddz)*(1-ddx)*a11+ddz*(1-ddx)*a21+
                    (1-ddz)*ddx*a12+ddz*ddx*a22

xmax=ox+(nx-1)*dx
zmax=oz+(nz-1)*dz

# Check if shot coordinates are outside model
if( (xshot.lt.ox.or.xshot.gt.xmax) .or. (zshot.lt.oz.or.zshot.gt.zmax) ) {
  call seperr ('Shot coordinates are outside grid model' )
}

# Initialize constants
PI = 4.*atan(1.)

rmax = or + (nr-1)*dr
        
# Loop in Radius and Theta and express the slowness in cylindrical coordinates
xmax=ox+(nx-2)*dx
zmax=oz+(nz-2)*dz

do ir=1,nr {

  rr=or+(ir-1)*dr

  do it=1,nth {

    theta=oth+(it-1)*dth
    xx=rr*sin(theta)+xshot
    zz=rr*cos(theta)+zshot

# xx and zz stay within the boundaries (ox,xmax) respectively (oz,zmax)
    xx=max(ox,xx)
    xx=min(xmax,xx)
    zz=max(oz,zz)
    zz=min(zmax,zz)
# Find index in the (X,Z) grid
    ix=int((xx-ox)/dx)+1
    iz=int((zz-oz)/dz)+1

    ddx=(xx-ox)/dx-ix+1
    ddz=(zz-oz)/dz-iz+1
    ix=min(ix,nx-1)
    iz=min(iz,nz-1)

    a11=rectmap(iz,ix)
    a21=rectmap(iz+1,ix)
    a12=rectmap(iz,ix+1)
    a22=rectmap(iz+1,ix+1)
    polmap(it,ir)=bilint(ddz,ddx,a11,a21,a12,a22)
  }
}

return
end
