      subroutine wavetott(wavefield, nth,  time, timeprev, 
          amp, phase, nom, omega, 
          envelope, onewave, cmpshift, cmptmp, 
          winmin, winmin1, winmin2, winmin3,
          nsamp , dr, slowness, dt )


      integer nth,nom,nsamp 
      real dr,dt

      real omega(nom)

      complex wavefield(nth,nom)

      real amp(nth)
      real time(nth)
      real timeprev(nth)
      real phase(nth)
      real slowness(nth)

      real envelope(nsamp)
      complex onewave(nom)
      complex cmpshift(nom)
      complex cmptmp(nom)

      real winmin(nth)
      real winmin1(nth)
      real winmin2(nth)
      real winmin3(nth)

      real tmptime

      real maxtime
      real maxamp

      real delf
      real del2f

      complex cdata,cdata2,ctmp

      integer i,j,k,ith

#
#       for each angle do a slow transform back to the energy of
#       the signal for each time sample
#

#       minimum travel time to image at this radius

do i=1,nth {
    winmin(i) = timeprev(i) + real(-nsamp/2)*dt + dr*slowness(i)
    if( winmin(i) .lt. 0. ) winmin(i)=0.
}

call median3( winmin, winmin1, winmin2, winmin3, nth )

#precomputed shifts by one sample
do k = 1,nom { cmpshift(k)  = cexp( cmplx( 0., -dt*omega(k) ) ) }

do ith = 1,nth {

    do i = 1, nom { onewave(i) = wavefield(ith,i) }

# calculate envelope for nsamp traveltime, use precomputed cexp shifts

    cdata = 0.
    do k = 1,nom {
       onewave(k) = onewave(k)*cmplx( cos(winmin(ith)*omega(k)),-sin(winmin(ith)*omega(k)) )
       cdata=cdata+onewave(k) 
    }
    envelope(1) = cabs(cdata)

    do j = 2,nsamp{
        cdata=0.
        do k = 1,nom {
           onewave(k) = onewave(k)*cmpshift(k) # shift by dt
	   cdata=cdata+onewave(k)
        }
        envelope(j) = cabs(cdata)
    }

    do i = 1, nom { onewave(i) = wavefield(ith,i) }
#
#       pick the maximum value 
#       use its amplitude and time (for now)

     maxtime = 0. ; maxamp = 0.
	
     do j = 1,nsamp{
         if( envelope(j) > maxamp ){
             maxamp = envelope(j)
	     maxtime  = winmin(ith) + real(j-1)*dt
         }
     }
#
#     tune up the traveltimes
#
	
#       first calculate gradient and curvature

     do k=1,nom {cmptmp(k)=cmplx(cos(omega(k)*maxtime),sin(omega(k)*maxtime))}

     delf =0.	
     del2f =0.	
     do i = 1,nom{
         cdata=0.
         cdata2=0.
         do k = 1,nom{
	      ctmp = cmptmp(i)*conjg(cmptmp(k))
              cdata = cdata +  
                cmplx(0.,(omega(i)-omega(k))) * ctmp * onewave(k)
              cdata2 = cdata2 -  
               (omega(i)-omega(k))**2 * ctmp * onewave(k)
         }
         delf = delf +  real( conjg(onewave(i)) * cdata ) 
         del2f = del2f +  real( conjg(onewave(i)) * cdata2 ) 
     }
        
#       locate maximum  ( quadratic fit (limit to one samp) )
     delf = delf/del2f
     if( abs(delf).lt. dt ) maxtime = maxtime - delf 
     time(ith) = maxtime

#	calculate amplitude and phase at this point

     cdata=0.
     do k = 1,nom {
          cdata=cdata+
        onewave(k)* cmplx( cos(maxtime*omega(k)), -sin(maxtime*omega(k)) )
     }

     amp(ith) = cabs( cdata )
     phase(ith) =  atan2( aimag(cdata), real(cdata ))

} # end of loop on theta

return
end

subroutine median3( winmin, winmin1,winmin2,winmin3, nth )

real winmin(nth)

real winmin1(nth)
real winmin2(nth)
real winmin3(nth)

do i=1,nth-1 { winmin1(i) = winmin(i+1) } ; winmin1(nth) = winmin(nth)
do i=1,nth { winmin2(i) = winmin(i) }
do i=2,nth { winmin3(i) = winmin(i-1) } ; winmin3(1) = winmin(1)


#       Take 3 point median of winmin
#       Three phase bubble sort then take middle

do i=1,nth {
   if( winmin3(i) .lt. winmin2(i)  ){
            winmin(i) = winmin2(i)
	    winmin2(i)=winmin3(i)
	    winmin3(i)=winmin(i)
    }
    if( winmin2(i) .lt. winmin1(i)  ){
	    winmin2(i)=winmin1(i)
    }
    if( winmin3(i) .lt. winmin2(i)  ){
	    winmin2(i)=winmin3(i)
    }

    winmin(i) = winmin2(i)
}

return
end
